config/routes.rb
require 'sidekiq/web'
require 'sidekiq/cron/web'

Rails.application.routes.draw do
  root 'pages#index'
  post 'send' => 'pages#create'
  get 'about' => 'pages#about'

  get 'gallery' => 'images#index'
  resources :images, except: [:index]

  resources :messages, except: [:show]
  get 'message' => 'messages#show', as: :show_message

  resources :slides, except: [:show]
  resources :announcements, :path => 'ans'
  resources :subscribers, only: [:create]
  get 'subs/:id' => 'subscribers#destroy', as: :subs_destroy

  get 'hashmin/login' => 'sessions#new', as: :login
  post 'hashmin/login' => 'sessions#create'
  get 'hashmin/logout' => 'sessions#destroy', as: :logout
  get 'hashmin/:id' => 'admins#index', as: :admin
  resources :admins, except: [:show], path: 'hashmin'

  resources :password_resets, only: [:new, :create, :edit, :update]

  mount Sidekiq::Web => '/sidekiq'

end

app/models/announcement.rb
class Announcement < ActiveRecord::Base
  default_scope -> { order(expires_at: :asc) }

  validates :title, presence: true, length: {maximum: 50}
  validates :desc, presence: true
  validates :expires_at, presence: true
  validate :validate_expires_at

  after_save :announce

  private
    def validate_expires_at
      if expires_at.present?
        if expires_at < Date.tomorrow
          errors.add(:expires_at, "must be at least 1 day from now")
        end
      end
    end

    def expired?
      if self.expires_at < Date.today
        true
      else
        false
      end
    end

    def announce
      AnnounceJob.perform_later self
    end
end

app/controllers/announcements_controller.rb
class AnnouncementsController < ApplicationController
  before_action :logged_in_admin, only: [:new, :create, :edit, :update, :destroy]
  before_action :get_an, only: [:show, :edit, :update, :destroy]

  def index
    @ans = Announcement.all
  end

  def show
  end

  def new
    @an = Announcement.new
  end

  def create
    @an = Announcement.new(an_params)
    if @an.save
      flash[:success] = "Announcement successfully created"
      redirect_to @an
    else
      render 'new'
    end
  end

  def edit
    render 'new'
  end

  def update
    if @an.update_attributes(an_params)
      flash[:success] = "Announcement successfully updated"
      redirect_to @an
    else
      render 'edit'
    end
  end

  def destroy
    @an.destroy
    flash[:info] = "Announcement successfully deleted"
    redirect_to announcements_path
  end

  private
    def an_params
      params.require(:announcement).permit(:title, :desc, :expires_at)
    end

    def get_an
      @an = Announcement.find(params[:id])
    end
end

app/helpers/announcements_helper.rb
module AnnouncementsHelper
end

app/views/announcements/_announcement.html.haml
.an.cf
  - an ||= announcement
  = link_to an.title, an  if params[:action] != 'show'
  = content_tag :h3, an.title  if params[:action] == 'show'
  %p
    = params[:controller] == 'announcements' ? truncate(an.desc, length: 300) : truncate(an.desc, length: 110) if params[:action] != 'show'
    = simple_format an.desc if params[:action] == 'show'
  = link_to "Back", announcements_path, class: "delete"  if params[:action] == 'show'
  = link_to "Edit", edit_announcement_path(an), class: "delete" if logged_in? && params[:action] == 'show'
  = link_to "Delete", an, method: :delete, class: "delete", data: {confirm: "Are you sure?"} if logged_in? && params[:action] == 'show'
  %span
    Lasts till: #{an.expires_at.strftime("%H:%M %A, %d %B %Y")}
= raw "<hr>" if params[:action] != 'show'

app/views/announcements/index.html.haml
#pushDown

#ans
  = render @ans

app/views/announcements/new.html.haml
= form_for(@an) do |f|
  = render 'shared/form_top'
  = render 'shared/errors', object: f.object
  .field
    = f.label :title
    = f.text_field :title
  .field
    = f.label :desc
    = f.text_area :desc
  .field
    = f.label :expires_at
    = f.date_select :expires_at
  = f.submit "Save Announcement"

app/views/announcements/show.html.haml
#pushDown

#anShow
  = render @an